\documentclass{article}
\usepackage{geometry}
\usepackage{amsmath}
\usepackage{graphicx}
\usepackage{listings}
\usepackage{color}        
\usepackage{natbib}
\usepackage{appendix}
\usepackage{xcolor}
\usepackage{float}
\usepackage{caption}
\usepackage{subcaption}

\definecolor{codegreen}{rgb}{0,0.6,0}
\definecolor{codegray}{rgb}{0.5,0.5,0.5}
\definecolor{codepurple}{rgb}{0.58,0,0.82}
\definecolor{backcolour}{rgb}{0.95,0.95,0.92}

\DeclareRobustCommand{\comment}[1]{
    {\color{orange}\emph{#1}}
}

%For handling code, addapt depending on language
\lstdefinestyle{mystyle}{
    backgroundcolor=\color{backcolour},   
    commentstyle=\color{codegreen},
    keywordstyle=\color{magenta},
    numberstyle=\tiny\color{codegray},
    stringstyle=\color{codepurple},
    basicstyle=\ttfamily\footnotesize,
    breakatwhitespace=false,         
    breaklines=true,                 
    captionpos=b,                    
    keepspaces=true,                 
    numbers=left,                    
    numbersep=5pt,                  
    showspaces=false,                
    showstringspaces=false,
    showtabs=false,                  
    tabsize=2
}
\lstset{style=mystyle}

\title{Prototyping generics in LFortran}
\author{
    Sander Wiig\footnote{Department of Informatics, University of Bergen, Norway}\\
    \and
    Prof. Magne Haveraaen\footnote{Bergen Language Design Laboratory (BLDL), Department of Informatics, University of Bergen, Norway}\\
}

\begin{document}
    \maketitle

    \begin{abstract}
        This report will summarize and describe our approach toward implementing a generics mechanism in the LFortran compiler that is in line with the decisions of the Fortran 20xx generics subcommittee. 
        Our method modifies LFortrans Abstract Semantic Representation to allow for generics programming by introducing a type of symbol called a Signature that describes a type and operations on the said type.
        This allows us to nest arrays, a secondary goal for the project.
    \end{abstract}

    \section{Introduction}
        Fortran is a general-purpose, imperative programming language mainly used for scientific computing
        but has lacked a generics mechanism since its inception. To remedy this, the Fortran committee has established a generics subcommittee to investigate and craft a proposal for implementing generics. The lack of generics is a major hindrance for developers as they are unable to take advantage of modern programming techniques that are present in 
        other more modern programming languages.\\
        There are multiple ways of implementing generics, but it was decided to follow the guidelines established by Haveraaen et.al.\cite{haveraaen19} which also aligns with the proposal put forward by the Fortran subcomitees\cite{generics22}.\\
        Namely, any generic mechanism needs to be typesafe, have the same degree of support for intrinsic and user-defined types, and let generic parameters be extended/nested \cite{haveraaen19}.
        LFortran is built on an Abstract Semantic Representation(ASR). By modifying this data structure, we can allow the backend to support 
        generics without having to have a concrete syntactical model ready.

    \section{The Abstract Semantic Representation of LFORTRAN}

    \subsection{The ASDL Format}
        The ASR is a tree structure that models the semantics of a program, and it can be considered an abstract syntax tree for representing semantics instead of syntax.
        Since the ASR is semantically valid Fortran code, it becomes possible for the compiler to do transformations that will 
        always be valid\cite{asr}.\\
        One exciting aspect is that other programming languages can target the ASR. This lets programmers view code that is semantically the same but in their language of choice\footnote{Similarly to languages that target CLI like C\# and Visual C++}.
        The ASR is implemented in the Zephyr Abstract Syntax Description Language (ASDL). The format was initially supposed to describe the 
        the abstract syntax of compiler intermediate representations or similar structures is well suited to the ASR \cite{asdl}.
        ASDL provides a notation similar to the Extended Backus-Naur Form (EBNF).\\
        LFortran has further modified ASDL by extending its type system with booleans, floating-point numbers, a symbol table data struct, and a Node struct
        to better represent the semantics of Fortran\cite{asr} .\\
    
    \subsection{Semantics of LFORTRAN}
        The Translation unit is a tuple consisting of a symbol table and a tree of nodes.
        \begin{figure}[!h]
            \centering
            \begin{lstlisting}
    translation_unit = (symbol_table global_scope, node* items)
                \end{lstlisting}
        \end{figure}
        The network of nodes describes the program structure where a Node is either a Statement, Expression or Symbol.
        \begin{figure}[!h]
            \centering
            \begin{lstlisting}
    node = Symbol(symbol s) | Stmt(stmt s)| Expr(expr e)
            \end{lstlisting}
        \end{figure}
        
        The other part is the global symbol table which contains all the program declarations and definitions.
        The symbol table consists of an optional pointer to a parent symbol table, the symbol table id, and an Identifier$\rightarrow $Symbol mapping
        \begin{figure}[!h]
            \centering
            \begin{lstlisting}
    symbol_table = (symbol_table? parent_symtab, identifier name, (identifier symbol_name, symbol sym)*)
            \end{lstlisting}
            \caption{The ASR symbol table}
        \end{figure}
        
        The only other thing of note is the TType datastructure that represents different types. Note DerivedType.
        \begin{figure}[!h]
            \begin{lstlisting}
    ttype
        = Integer(int kind, dimension* dims)
        | Real(int kind, dimension* dims)
        | Complex(int kind, dimension* dims)
        | Character(int kind, int len, expr? len_expr, dimension* dims)
        | Logical(int kind, dimension* dims)
        | Derived(symbol derived_type, dimension* dims)
        | Class(symbol class_type, dimension* dims)
        | Dict(ttype key_type, ttype value_type)
        | Pointer(ttype type)
        | Set(ttype type)
                \end{lstlisting} 
            \caption{ASR TTypes}
        \end{figure} 
    
    \section{Rewriting the ASR to allow generics}

    \subsection{Requirements}
        Haveraaen 2019 \cite{haveraaen19} states that a generic mechanism should have the following properties.
        \begin{itemize}
            \item Generic arguments should treat intrinsic and derived types the same.
            \item Generic parameters should be types, operations with full prototype declarations or typed values, and type checkable.
            \item It should be possible to nest generic definitions.
            \item When instantiating generic code, it should be possible to rename the defined types.
            \item Reusable naming lists should be supported.
        \end{itemize}
        We can accomplish these goals by rewriting the ASR.
        
    \subsection{Creating a shared type constructor}
        By examining the TType data struct, we can see that nearly all intrinsic types share the same constructor design\footnote{Exception is Character, but we can abstract away the extra constructor parameters}.
        \begin{figure}[!h]
            \begin{lstlisting}
    --For a full list of TTypes, see Appendix A.
    Integer(int kind, dimension* dims)
    | Real(int kind, dimension* dims)
    | Complex(int kind, dimension* dims)
    | Character(int kind, int len, expr? len_expr, dimension* dims)
    | Logical(int kind, dimension* dims)
            \end{lstlisting}
            \caption{Type constructors with similar fields}
        \end{figure}
        
        We can simplify the above into a single constructor called DefinableType, which contains the above common fields and links to a Symbol that defines type-specific behavior and intrinsic agnostic implementation.
        \begin{figure}[!h]
            \centering
            \begin{lstlisting}
    DefinableType(int? kind, symbol signature, dimension* dims)
            \end{lstlisting}
        \end{figure}
        
        Now that we have simplified our types, we modify our expressions to reflect the change by folding all the constant constructors into one.
        This means that the semantic representation no longer inherently favors intrinsic types.\\
        The simplification does, however, present some issues.\\
        First, we no longer have any way to construct intrinsic constants since we simplified away the intrinsic constants.
        The solution chosen in this case is to have a parameter of the type String that contains the data.
        A natural extension would be to serialize the data and store it as a byte array instead of a String, but a String was chosen to make it easier to work with and should suffice.
    \subsection{Type Signatures}
        Another issue we now face is how to describe which operations are allowed on what types. 
        Currently, there are expressions for binary, boolean, unary, string, and casting operations.
        The problem is that these are only defined for intrinsic types. What if we wanted to create a kind that could be added.
        To solve this, we decouple the operations of a type from the expression structure. 
        We do this by creating a new symbol that we call Signature.
        \begin{figure}[!h]
            \centering
            \begin{lstlisting}
    Signature(symbol_table parent_symtab,declared_types ttype*, identifier name, symbol* members)
            \end{lstlisting}
        \end{figure}
        This signature contains every operation that involves the corresponding type as functions.\\
        We specify that all intrinsic functions should be intrinsic by using setting the application binary interface to Intrinsic
        which means that the implementation is implicitly part of the language.

        The example below shows the difference between $2+2$ in the original ASR and our modified one \footnote{Note: The expressions above are Haskell data structures.}.
        \begin{figure}[!h]
            \centering
            \begin{subfigure}{\textwidth}
                \centering
                \begin{lstlisting}                   
(BinOp 
    (ConstantInteger 2 (Integer 1 [])),
    PLUS,
    (ConstantInteger 2 (Integer 1 [])),
    (Integer 1 [])
)
                \end{lstlisting}
                \label{fig:sub1}
                \caption{LFortran ASR}
            \end{subfigure}
            \begin{subfigure}{\textwidth}
                \centering
                \begin{lstlisting}
(FunctionCall 
    "Plus",
    [
        (Constant
            (DefinableType 1 "Integer" []),
                "2"
        ),
        (Constant
            (DefinableType 1 "Integer" []),
                "2"
        )
    ],
    [],
    (DefinableType 1 "Integer" [])
)
                \end{lstlisting}
                \label{fig:post}
                \caption{Modified ASR}
            \end{subfigure}
            \label{fig:sub2}
            \caption{Signature Example}
        \end{figure}
        A more complex example can be viewed in \ref{appendix:sorting}.\\
        There are several ways of adding the signatures to the translation unit.
        In this case, we use modules. The signatures are imported as a module to make them available to the program. 
        Another possible approach would be to extend the translation unit with another symbol table parameter that contains the signatures.\\ 
        We have chosen the module approach for a few reasons. The first is that it is easier to implement.
        The second is that the module approach doesn't require any further modifications of the ASR. 
        This is important since it allows us to transform back and forth between the modified ASR and the original more easily.\\
        The modified Translation unit is, in all likelihood, superior as it is more robust and makes it easier for any compiler to access it instead of inspecting the modules.
        

    \subsection{Nesting Types}
        A long-running problem in Fortran has been the inability to nest arrays. The typical workaround has been to embed an array in a derived type.
        This is cumbersome for the developer and the compiler since it cannot perform specific array optimizations that would be possible if the arrays were directly nestable.
        Since Fortran arrays are not a seperate type, but a property of the type instead i.e dimension of a type.
        By seperating the dimension from the type definition into a type of its own we are able to nest arbitrary types.
        Further more by creating an array type we are able to both maintain FORTRANs original design of having dimensions while still allowing nesting of arrays by making
        them an explicit type.
        \begin{figure}[h]
            \centering
            \begin{lstlisting}
ttype
    = DefinableType(int? kind, symbol signature, ttype* dimension)
    | Dimension(expr? start, expr? stop)
    | Derived(symbol derived_type, ttype* dims)
    | Pointer(ttype type)
    | Array(ttype* nested_arrs, ttype array_type)
            \end{lstlisting}
            \caption{The new TType with Dimension}
        \end{figure}
    
    
    
    \section{Conclussion}
        Modifying the ASR has multiple advantages.\\
        By implementing signatures into the ASR, we can drastically reduce the size of the ASR by more than $\frac{1}{3}$, making it easier to implement the semantic representation.
        Signatures are an important step towards generics since there now exists a semantic framework that can support it. 
        Using modules for storing signatures is not optimal and should be replaced with a dedicated Translation unit parameter in any practical implementation. The same also applies to literals/constants.
        Strings are useful during prototyping, but data needs a more solid, high-performance representation in any real-life use case.\\
        Another major advantage of the modified ASR is that it can now nest arrays, solving the longstanding issue of needing to wrap arrays in user-defined types, therefore not allowing the compiler to perform the necessary optimizations.
        The modified ASR is a major step towards a generic Fortran.
    
    \bibliography{report} 
    \bibliographystyle{plain}
    
    \appendix
    \appendixpage
    \section{Generic Insertion Sort}\label{appendix:sorting}
        An everyday use case for generics is lists and sorting algorithms. This example\footnote{Note: The example is shown as a Haskell data structure} will show what a generic sorting algorithm would look like.
        \begin{figure}[!h]
            \begin{lstlisting}[language=Fortran]
pure subroutine insertion_sort( array )
!Bog-standard insertion sort.
    T, intent(inout) :: array(0:)
    integer :: i, j
    T :: key
    do j=0, size(array, kind=0) - 1
        key = array(j)
        i = j - 1
        do while( i >= 0 )
            if (array(i) == key ) exit
            array(i+1) = array(i)
            i = i - 1
        end do
        array(i+1) = key
    end do
end subroutine insertion_sort
            \end{lstlisting}
            \caption*{Insertion sort for generic arrays in Fortran}
        \end{figure}
        The above would have the following ASR representation
        \begin{lstlisting}
tsort::XASR
tsort=(TranslationUnit
    ( SymbolTable ( Nothing ) 1
        [
            ( "insertion_sort"
            ,
                ( Subroutine
                    ( SymbolTable
                        ( Just 1 ) 2
                        [
                            ( "array"
                            ,
                                ( Variable 2 "array" InOut Nothing Nothing Default
                                    ( DefinableType Nothing "T"
                                        [
                                            ( Dimension Just
                                                ( Constant
                                                    ( DefinableType Just 4 "Integer" [] ) "0"
                                                ) Nothing
                                            )
                                        ]
                                    ) Source Public Required False
                                )
                            )
                        ,
                            ( "i"
                            ,
                                ( Variable 2 "i" Local Nothing Nothing Default
                                    ( DefinableType Just 4 "Integer" [] ) Source Public Required False
                                )
                            )
                        ,
                            ( "j"
                            ,
                                ( Variable 2 "j" Local Nothing Nothing Default
                                    ( DefinableType Just 4 "Integer" [] ) Source Public Required False
                                )
                            )
                        ,
                            ( "key"
                            ,
                                ( Variable 2 "key" Local Nothing Nothing Default
                                    ( DefinableType Nothing "T" [] ) Source Public Required False
                                )
                            )
                        ,
                            ( "size"
                            ,
                                ( ExternalSymbol 2 "size" 4 "size" [] "size" Private )
                            )
                        ]
                    ) "insertion_sort"
                    [
                        ( Var 2 "array" )
                    ]
                    [
                        ( DoLoop
                            (
                                ( Var 2 "j" )
                            ,
                                ( Constant
                                    ( DefinableType Just 4 "Integer" [] ) "0"
                                )
                            ,
                                ( FunctionCall -1 "Integer_Sub"
                                    [
                                        ( FunctionCall 2 "size"
                                            [
                                                ( Var 2 "array" )
                                            ,
                                                ( Constant
                                                    ( DefinableType Just 4 "Integer" [] ) "0"
                                                )
                                            ] []
                                            ( DefinableType Just 4 "Integer" [] ) Nothing Nothing
                                        )
                                    ,
                                        ( Constant
                                            ( DefinableType Just 4 "Integer" [] ) "1"
                                        )
                                    ] []
                                    ( DefinableType Just 4 "Integer" [] ) Nothing Nothing
                                )
                            , Nothing
                            )
                            [
                                ( Assignment
                                    ( Var 2 "key" )
                                    ( ArrayRef 2 "array"
                                        [
                                            ( Nothing
                                            , Just
                                                ( Var 2 "j" )
                                            , Nothing
                                            )
                                        ]
                                        ( DefinableType Nothing "T"
                                            [
                                                ( Dimension Just
                                                    ( Constant
                                                        ( DefinableType Just 4 "Integer" [] ) "0"
                                                    ) Nothing
                                                )
                                            ]
                                        ) Nothing
                                    ) Nothing
                                )
                            ,
                                ( Assignment
                                    ( Var 2 "i" )
                                    ( FunctionCall -1 "Integer_Sub"
                                        [
                                            ( Var 2 "j" )
                                        ,
                                            ( Constant
                                                ( DefinableType Just 4 "Integer" [] ) "1"
                                            )
                                        ] []
                                        ( DefinableType Just 4 "Integer" [] ) Nothing Nothing
                                    ) Nothing
                                )
                            ,
                                ( While
                                    ( FunctionCall -1 "Logical_GtE"
                                        [
                                            ( Var 2 "i" )
                                        ,
                                            ( Constant
                                                ( DefinableType Just 4 "Integer" [] ) "0"
                                            )
                                        ] []
                                        ( DefinableType Just 4 "Logical" [] ) Nothing Nothing
                                    )
                                    [
                                        ( If
                                            ( FunctionCall -1 "T_Eq"
                                                [
                                                    ( ArrayRef 2 "array"
                                                        [
                                                            ( Nothing
                                                            , Just
                                                                ( Var 2 "i" )
                                                            , Nothing
                                                            )
                                                        ]
                                                        ( DefinableType Nothing "T"
                                                            [
                                                                ( Dimension Just
                                                                    ( Constant
                                                                        ( DefinableType Just 4 "Integer" [] ) "0"
                                                                    ) Nothing
                                                                )
                                                            ]
                                                        ) Nothing
                                                    )
                                                ,
                                                    ( Var 2 "key" )
                                                ] []
                                                ( DefinableType Just 4 "Logical" [] ) Nothing Nothing
                                            ) [ ( Exit ) ] []
                                        )
                                    ,
                                        ( Assignment
                                            ( ArrayRef 2 "array"
                                                [
                                                    ( Nothing
                                                    , Just
                                                        ( FunctionCall -1 "Integer_Add"
                                                            [
                                                                ( Var 2 "i" )
                                                            ,
                                                                ( Constant
                                                                    ( DefinableType Just 4 "Integer" [] ) "1"
                                                                )
                                                            ] []
                                                            ( DefinableType Just 4 "Integer" [] ) Nothing Nothing
                                                        )
                                                    , Nothing
                                                    )
                                                ]
                                                ( DefinableType Nothing "T"
                                                    [
                                                        ( Dimension Just
                                                            ( Constant
                                                                ( DefinableType Just 4 "Integer" [] ) "0"
                                                            ) Nothing
                                                        )
                                                    ]
                                                ) Nothing
                                            )
                                            ( ArrayRef 2 "array"
                                                [
                                                    ( Nothing
                                                    , Just
                                                        ( Var 2 "i" )
                                                    , Nothing
                                                    )
                                                ]
                                                ( DefinableType Nothing "T"
                                                    [
                                                        ( Dimension Just
                                                            ( Constant
                                                                ( DefinableType Just 4 "Integer" [] ) "0"
                                                            ) Nothing
                                                        )
                                                    ]
                                                ) Nothing
                                            ) Nothing
                                        )
                                    ,
                                        ( Assignment
                                            ( Var 2 "i" )
                                            ( FunctionCall -1 "Integer_Sub"
                                                [
                                                    ( Var 2 "i" )
                                                ,
                                                    ( Constant
                                                        ( DefinableType Just 4 "Integer" [] ) "1"
                                                    )
                                                ] []
                                                ( DefinableType Just 4 "Integer" [] ) Nothing Nothing
                                            ) Nothing
                                        )
                                    ]
                                )
                            ,
                                ( Assignment
                                    ( ArrayRef 2 "array"
                                        [
                                            ( Nothing
                                            , Just
                                                ( FunctionCall -1 "Integer_Add"
                                                    [
                                                        ( Var 2 "i" )
                                                    ,
                                                        ( Constant
                                                            ( DefinableType Just 4 "Integer" [] ) "1"
                                                        )
                                                    ] []
                                                    ( DefinableType Just 4 "Integer" [] ) Nothing Nothing
                                                )
                                            , Nothing
                                            )
                                        ]
                                        ( DefinableType Nothing "T"
                                            [
                                                ( Dimension Just
                                                    ( Constant
                                                        ( DefinableType Just 4 "Integer" [] ) "0"
                                                    ) Nothing
                                                )
                                            ]
                                        ) Nothing
                                    )
                                    ( Var 2 "key" ) Nothing
                                )
                            ]
                        )
                    ] Source Public Implementation Nothing False
                )
            )
        ,
            ( "Intrinsics"
            ,
                ( Module
                    ( SymbolTable ( Nothing ) 3 [] ) "Intrinsics" [] True
                )
            )
        ,
            ( "T"
            ,
                ( Module
                    ( 
                        SymbolTable ( Nothing ) 4 [("T", Signature 0 ["T"] "T" 
                            [
                                Function (
                                    SymbolTable (Just parent) addID [
                                                                        ("left", Variable addID "left" In Nothing Nothing Parameter (DefinableType (Just 0) "T" "T" []) Intrinsic Public Required False),
                                                                        ("right", Variable addID "right" In Nothing Nothing Parameter (DefinableType (Just 0) "T" "T" []) Intrinsic Public Required False),
                                                                        ("return", Variable addID "return" ReturnVar Nothing Nothing Parameter (DefinableType (Just 0) "T" "T" []) Intrinsic Public Required False)
                                                                    ]
                                        )
                                "T_Eq" [Var 4 "left", Var 4 "right" ] [] (Var 4 "return") Source Public Interface True Nothing
                            ]
                        )]
                    ) "T" [] True
                )
            )
        ]
    )
)
        \end{lstlisting}
    \section{The ASR and the modified ASR}
        \subsection{The ASR}
            \begin{lstlisting}
module ASR {

unit
    = TranslationUnit(symbol_table global_scope, node* items)

symbol
    = Program(symbol_table symtab, identifier name, identifier* dependencies,
        stmt* body)
    | Module(symbol_table symtab, identifier name, identifier* dependencies,
        bool loaded_from_mod)
    | Subroutine(symbol_table symtab, identifier name, expr* args, stmt* body,
        abi abi, access access, deftype deftype, string? bindc_name, bool pure,
        bool module)
    | Function(symbol_table symtab, identifier name, expr* args, stmt* body,
        expr return_var, abi abi, access access, deftype deftype,
        string? bindc_name)
    | GenericProcedure(symbol_table parent_symtab, identifier name,
        symbol* procs, access access)
    | CustomOperator(symbol_table parent_symtab, identifier name,
        symbol* procs, access access)
    | ExternalSymbol(symbol_table parent_symtab, identifier name,
        symbol external, identifier module_name, identifier* scope_names,
        identifier original_name, access access)
    | DerivedType(symbol_table symtab, identifier name, identifier* members,
        abi abi, access access, symbol? parent)
    | Variable(symbol_table parent_symtab, identifier name, intent intent,
        expr? symbolic_value, expr? value, storage_type storage, ttype type,
        abi abi, access access, presence presence, bool value_attr)
    | ClassType(symbol_table symtab, identifier name, abi abi, access access)
    | ClassProcedure(symbol_table parent_symtab, identifier name, identifier
        proc_name, symbol proc, abi abi)

storage_type = Default | Save | Parameter | Allocatable
access = Public | Private
intent = Local | In | Out | InOut | ReturnVar | Unspecified | AssociateBlock
deftype = Implementation | Interface
presence = Required | Optional

abi
    = Source
    | LFortranModule
    | GFortranModule  
    | BindC 
    | Interactive 
    | Intrinsic


stmt
    = Allocate(alloc_arg* args, expr? stat, expr? errmsg)
    | Assign(int label, identifier variable)
    | Assignment(expr target, expr value, stmt? overloaded)
    | Associate(expr target, expr value)
    | Cycle()
    | ExplicitDeallocate(symbol* vars)
    | ImplicitDeallocate(symbol* vars)
    | DoConcurrentLoop(do_loop_head head, stmt* body)
    | DoLoop(do_loop_head head, stmt* body)
    | ErrorStop(expr? code)
    | Exit()
    | ForAllSingle(do_loop_head head, stmt assign_stmt)
    | GoTo(int target_id)
    | GoToTarget(int id)
    | If(expr test, stmt* body, stmt* orelse)
    | IfArithmetic(expr test, int lt_label, int eq_label, int gt_label)
    | Print(expr? fmt, expr* values)
    | Open(int label, expr? newunit, expr? filename, expr? status)
    | Close(int label, expr? unit, expr? iostat, expr? iomsg, expr? err, expr? status)
    | Read(int label, expr? unit, expr? fmt, expr? iomsg, expr? iostat, expr? id, expr* values)
    | Rewind(int label, expr? unit, expr? iostat, expr? err)
    | Inquire(int label, expr? unit, expr? file, expr? iostat, expr? err,
              expr? exist, expr? opened, expr? number, expr? named,
              expr? name, expr? access, expr? sequential, expr? direct,
              expr? form, expr? formatted, expr? unformatted, expr? recl,
              expr? nextrec, expr? blank, expr? position, expr? action,
              expr? read, expr? write, expr? readwrite, expr? delim,
              expr? pad, expr? flen, expr? blocksize, expr? convert,
              expr? carriagecontrol, expr? iolength)
    | Write(int label, expr? unit, expr? fmt, expr? iomsg, expr? iostat, expr? id, expr* values)
    | Return()
    | Select(expr test, case_stmt* body, stmt* default)
    | Stop(expr? code)
    | Assert(expr test, expr? msg)
    | SubroutineCall(symbol name, symbol? original_name, call_arg* args, expr? dt)
    | Where(expr test, stmt* body, stmt* orelse)
    | WhileLoop(expr test, stmt* body)
    | Nullify(symbol* vars)
    | Flush(int label, expr unit, expr? err, expr? iomsg, expr? iostat)


expr
    = BoolOp(expr left, boolop op, expr right, ttype type, expr? value)
    | BinOp(expr left, binop op, expr right, ttype type, expr? value, expr? overloaded)
    | StrOp(expr left, strop op, expr right, ttype type, expr? value)
    | UnaryOp(unaryop op, expr operand, ttype type, expr? value)
        -- Such as: (x, y+z), (3.0, 2.0) generally not known at compile time
    | ComplexConstructor(expr re, expr im, ttype type, expr? value)
    | NamedExpr(expr target, expr value, ttype type)
    | Compare(expr left, cmpop op, expr right, ttype type, expr? value, expr? overloaded)
    | IfExp(expr test, expr body, expr orelse, ttype type)
    | FunctionCall(symbol name, symbol? original_name,
            call_arg* args, ttype type, expr? value, expr? dt)
    | DerivedTypeConstructor(symbol dt_sym, expr* args, ttype type)
    | ConstantArray(expr* args, ttype type)
    | ImpliedDoLoop(expr* values, expr var, expr start, expr end,
                    expr? increment, ttype type, expr? value)
    | ConstantInteger(int n, ttype type)
    | ConstantReal(float r, ttype type)
    | ConstantComplex(float re, float im, ttype type)
    | ConstantLogical(bool value, ttype type)
    | ConstantSet(expr* elements, ttype type)
    | ConstantString(string s, ttype type)
    | ConstantDictionary(expr* keys, expr* values, ttype type)
    | BOZ(int v, boz boz_type, ttype? type)
    | Var(symbol v)
    | ArrayRef(symbol v, array_index* args, ttype type, expr? value)
    | DerivedRef(expr v, symbol m, ttype type, expr? value)
    | ImplicitCast(expr arg, cast_kind kind, ttype type, expr? value)
    | ExplicitCast(expr arg, cast_kind kind, ttype type, expr? value)

ttype
    = Integer(int kind, dimension* dims)
    | Real(int kind, dimension* dims)
    | Complex(int kind, dimension* dims)
    | Character(int kind, int len, expr? len_expr, dimension* dims)
    | Logical(int kind, dimension* dims)
    | Derived(symbol derived_type, dimension* dims)
    | Class(symbol class_type, dimension* dims)
    | Dict(ttype key_type, ttype value_type)
    | Pointer(ttype type)
    | Set(ttype type)

boolop = And | Or | Xor | NEqv | Eqv

binop = Add | Sub | Mul | Div | Pow

unaryop = Invert | Not | UAdd | USub

strop = Concat | Repeat

cmpop = Eq | NotEq | Lt | LtE | Gt | GtE

boz = Binary | Hex | Octal

cast_kind
    = RealToInteger
    | IntegerToReal
    | RealToReal
    | IntegerToInteger
    | RealToComplex
    | IntegerToComplex
    | IntegerToLogical
    | ComplexToComplex
    | ComplexToReal

dimension = (expr? start, expr? end)

alloc_arg = (symbol a, dimension* dims)

attribute = Attribute(identifier name, attribute_arg *args)

attribute_arg = (identifier arg)

call_arg = (expr? value)

tbind = Bind(string lang, string name)

array_index = (expr? left, expr? right, expr? step)

do_loop_head = (expr? v, expr? start, expr? end, expr? increment)

case_stmt = CaseStmt(expr* test, stmt* body) | CaseStmt_Range(expr? start, expr? end, stmt* body)

}

            \end{lstlisting}
        \subsection{The Modified ASR}
        \begin{lstlisting}
module ASR {

unit
    = TranslationUnit(symbol_table global_scope, node* items, symbol_table intrinsics)

symbol
    = Program(symbol_table symtab, identifier name, identifier* dependencies,
        stmt* body)
    | Module(symbol_table symtab, identifier name, identifier* dependencies,
        bool loaded_from_mod)
    | Subroutine(symbol_table symtab, identifier name, expr* args, stmt* body,
        abi abi, access access, deftype deftype, string? bindc_name, bool pure,
        bool module)
    | Function(symbol_table symtab, identifier name, expr* args, stmt* body,
        expr return_var, abi abi, access access, deftype deftype,
        string? bindc_name)
    | GenericProcedure(symbol_table parent_symtab, identifier name,
        symbol* procs, access access)
    | CustomOperator(symbol_table parent_symtab, identifier name,
        symbol* procs, access access)
    | ExternalSymbol(symbol_table parent_symtab, identifier name,
        symbol external, identifier module_name, identifier* scope_names,
        identifier original_name, access access)
    | DerivedType(symbol_table symtab, identifier name, identifier* members,
        abi abi, access access, symbol? parent)
    | Variable(symbol_table parent_symtab, identifier name, intent intent,
        expr? symbolic_value, expr? value, storage_type storage, ttype type,
        abi abi, access access, presence presence, bool value_attr)
    | Signature(symbol_table parent_symtab, declared_types ttype*, identifier name, symbol* members)

storage_type = Default | Save | Parameter | Allocatable
access = Public | Private
intent = Local | In | Out | InOut | ReturnVar | Unspecified | AssociateBlock
deftype = Implementation | Interface
presence = Required | Optional

abi
    = Source
    | LFortranModule
    | GFortranModule  
    | BindC 
    | Interactive 
    | Intrinsic

stmt
    = Allocate(alloc_arg* args, expr? stat, expr? errmsg)
    | Assign(int label, identifier variable)
    | Assignment(expr target, expr value, stmt? overloaded)
    | Associate(expr target, expr value)
    | Cycle()
    | Deallocate(symbol* vars)
    | DoConcurrentLoop(do_loop_head head, stmt* body)
    | DoLoop(do_loop_head head, stmt* body)
    | ErrorStop(expr? code)
    | Exit()
    | ForAllSingle(do_loop_head head, stmt assign_stmt)
    | GoTo(int target_id)
    | GoToTarget(int id)
    | If(expr test, stmt* body, stmt* orelse)
    | IfArithmetic(expr test, int lt_label, int eq_label, int gt_label)
    | Return()
    | Select(expr test, case_stmt* body, stmt* default)
    | Stop(expr? code)
    | Assert(expr test, expr? msg)
    | SubroutineCall(symbol name, symbol? original_name, call_arg* args, expr? dt)
    | Where(expr test, stmt* body, stmt* orelse)
    | WhileLoop(expr test, stmt* body)
    | Nullify(symbol* vars)


expr
    = FunctionCall(symbol name, symbol? original_name,
            call_arg* args, ttype type, expr? value, expr? dt)
    | ImpliedDoLoop(expr* values, expr var, expr start, expr end, expr? increment, ttype loop_type, expr? value)
    | DerivedTypeConstructor(symbol dt_sym, expr* args, ttype type)
    | Var(symbol v)
    | ArrayRef(symbol v, array_index* args, ttype type, expr? value)
    | DerivedRef(expr v, symbol m, ttype type, expr? value)
    | Constant(ttype type, string data)
    | ConstantArray(expr* elements, ttype arrayType)
    
ttype
    = DefinableType(int? kind, symbol signature)
    | Pointer(ttype type)
    | Array(ttype array_type, dimension* dims)

dimension = (Expr? start, Expr? stop)
alloc_arg = (symbol a, dimension* dims)

attribute = Attribute(identifier name, attribute_arg *args)

attribute_arg = (identifier arg)

call_arg = (expr? value)

tbind = Bind(string lang, string name)

array_index = (expr? left, expr? right, expr? step)

do_loop_head = (expr? v, expr? start, expr? end, expr? increment)

case_stmt 
        = CaseStmt(expr* test, stmt* body) 
        | CaseStmt_Range(expr? start, expr? end, stmt* body)

}
        \end{lstlisting}
\end{document}